#!/usr/bin/env perl
#
# Dumplevel-0.2.pm
#

package Dumplevel;
require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(dumplevel);

use Time::Local;

sub dumplevel {
  my $L0_interval = shift(@_) or die "dumplevel(): Falscher Aufruf";
  my $L1_interval = shift(@_) or die "dumplevel(): Falscher Aufruf";
  my $L2_interval = shift(@_) or die "dumplevel(): Falscher Aufruf";
  my $dumpdates = shift(@_) || '/etc/dumpdates';
  
  my %monat = qw (Jan 1 Feb 2 Mar 3 Apr 4 May 5 Jun 6 Jul 7 Aug 8 Sep 9 Oct 10 Nov 11 Dec 12);
  my ($day, $month, $year) = (localtime)[3, 4, 5];
  $year = $year + 1900;

  my $epoch = timelocal(0, 0, 0, $day, $month +1, $year);

  open FH, $dumpdates or die "Kann die Datei $dumpdates nicht oeffnen\n";

  my $L0 = 0;
  my $L1 = 0;
  my $L2 = 0;
  my $x0 = 1;
  my $x1 = 1;
  my $L0_date;
  while (<FH>) {
    $_ =~ /(\d) ([A-z]{3}) ([A-z]{3}) (\d\d).{10}(20[0-9]{2})/;
    my $mm = $monat{$3};
    my $dumpdate = timelocal(0, 0, 0, $4, $mm, $5);
    my $age = ($epoch - $dumpdate) / 86400;
    exit 0 if $age < $L2_interval;
    if ($1 == 0) {
      $x0 = 0;
      $L0_date = $dumpdate;
      if ($age >= $L0_interval) { $L0 = 1}
      }
    elsif ($1 == 1) {
      $x1 = 0;
      if ($age >= $L1_interval) { $L1 = 1 }
      }
    elsif ($1 == 2) {
      if ($age >= $L2_interval) { $L2 = 1 }
      }  
    }
    
  close FH;

  return 0 if $L0 || $x0;
  return 1 if $L1;
  if ($x1) {
    return 1 if ((($epoch - $L0_date) / 86400) >= $L1_interval);
    }
  return 2;
  }

1 ;

__END__

=head1 NAME

Dumplevel - Gibt den erforderlichen Dumplevel zurueck

=head1 SYNOPSIS

use Dumplevel;

$LEVEL = dumplevel($L0_interval, $L1_interval, $L2_interval, $datesfile);

=head1 DESCRIPTION

Diese Funktion liest die Datei /etc/dumpdates aus und ermittelt den naechsten
erforederlichen Dumplevel fuer das Backupprogramm "dump". Sie erwartet als
Argumente die Intervalle fuer Level 0, Level 1 und Level 2 Dumps in Tagen. Das vierte
Argument ist optional. Es erwartet die Datei in der die "Dumpdates" gespeichert sind
(Standard = /etc/dumpdates).
Wenn die Datei $datesfile leer ist, wird mit einem Level 0 Dump begonnen.
Es werden dann je nach festgelegtem Level 2 Intervall ein Level 2 Dump durchgefuehrt,
ausser es steht ein Level 1 oder Level 0 Dump an. Fruehestens nach den in $L1_interval
festgelegten Tage wird ein Level 1 Dump durchgefuehrt. Ein Level 0 Dump wird dann nach
der in $L0_interval festgelegtan Anzahl von Tagen durchgefuehrt.

=cut
